#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

int main(int argc, char **argv) {
  HMIDIIN hMidiIn;
  MMRESULT res;
  UINT devid;
  char errmsg[MAXERRORLENGTH];

  if (argc > 1) {
    sscanf(argv[1], "%u", &devid);
  } else {
    devid = 0u;
  }

  res = midiInOpen(&hMidiIn, devid, (DWORD_PTR)NULL, 0, CALLBACK_NULL);
  if (res != MMSYSERR_NOERROR) {
    printf("Cannot open MIDI input device (ID=%u): ", devid);
    midiInGetErrorText(res, errmsg, sizeof(errmsg));
    printf("%s\n", errmsg);
    return 1;
  }
  printf("Succeeded to open a MIDI input device (ID=%u).\n", devid);

  midiInClose(hMidiIn);
  printf("Closed a MIDI input device.\n");

  return 0;
}
