#include <stdio.h>
#include <windows.h>
#include <mmsystem.h>

void CALLBACK my_callback(HMIDIIN hMidiIn, UINT wMsg, DWORD dwInstance,
                          DWORD dwParam1, DWORD dwParam2) {
  printf("MidiInProc: wMsg=%08X, p1=%08X, p2=%08X\n",
         wMsg, dwParam1, dwParam2);
}

int main(int argc, char **argv) {
  HMIDIIN hMidiIn;
  MMRESULT res;
  UINT devid;
  char errmsg[MAXERRORLENGTH];

  if (argc > 1) {
    sscanf(argv[1], "%u", &devid);
  } else {
    devid = 0u;
  }

  res = midiInOpen(&hMidiIn, devid, (DWORD_PTR)my_callback, 0, CALLBACK_FUNCTION);
  if (res != MMSYSERR_NOERROR) {
    printf("Cannot open MIDI input device (ID=%u): ", devid);
    midiInGetErrorText(res, errmsg, sizeof(errmsg));
    printf("%s\n", errmsg);
    return 1;
  }
  printf("Succeeded to open a MIDI input device (ID=%u).\n", devid);

  midiInStart(hMidiIn);

  while (1) {
    Sleep(10);
  }

  midiInStop(hMidiIn);
  midiInReset(hMidiIn);

  midiInClose(hMidiIn);
  printf("Closed a MIDI input device.\n");

  return 0;
}
