#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include "nksmf.h"
#include "nksmf-lib.h"

/* SMFt@CJ */
int smfOpenFile(FILE **fp, char *filename) {
  *fp = fopen(filename, "rb");
  if ( !(*fp) ) {
    return errno;
  }
  
  return 0;
}

/* SMFt@C */
int smfCloseFile(FILE *fp) {
  if ( !fclose(fp) ) {
    return errno;
  }
  
  return 0;
}

/* t@C̐擪oCgiwb_`Nj𒲂ׁC
 * t@CSMFtH[}bgĂ邩؂    */
int smfHasValidHeader(FILE *fp) {
  char buf[SMF_VALIDHEADERLEN];
  size_t ret;
  int i;
  
  if (!fp) {
    return 0;
  }
  
  /* t@C̓ǂݍ݈ʒu擪ɖ߂ */
  rewind(fp);
  /* t@C SMF_VALIDHEADERLEN oCgǂݍ */
  ret = fread(buf, sizeof(char), SMF_VALIDHEADERLEN, fp);
  
  /* f[^TCY{̃TCYCf[^vȂΌ؂Ɏs */
  if ( ret < SMF_VALIDHEADERLEN ||
       memcmp(buf, SMF_VALIDHEADERSTR, SMF_VALIDHEADERLEN) != 0 ) {
    return 0; /* invalid */
  }
  
  return 1; /* valid */
}

int smfGetHeaderChunk(FILE *fp, SMFHEADER *header) {
  size_t ret;

  /* t@C̓ǂݍ݈ʒu擪ɖ߂ */
  rewind(fp);
  /* t@C SMF_HEADERSIZE oCgǂݍ */
  ret = fread(header, SMF_HEADERSIZE, 1, fp);
  
  /* t@C̏I[ɓB邩G[ 0 ȊO̒lԂ */
  if (ret < 1) {
    if ( feof(fp) ) {
      return EOF;
    } else {
      return errno;
    }
  }

  /* GfBAϊ */
  header->length = convendian_uint32(header->length);
  header->format = convendian_uint16(header->format);
  header->numtrack = convendian_uint16(header->numtrack);
  header->timebase = convendian_uint16(header->timebase);
  
  return 0;
}

/* GfBAϊ֐ (4oCg̕p) */
long unsigned int convendian_uint32(long unsigned int obj) {
  long unsigned int ret = 0;
  int i;
  
  for (i=0; i<4; i++) {
    ret = ret << 8;
    ret |= ((unsigned char *)&obj)[i];
  }
  
  return ret;
}

/* GfBAϊ֐ (2oCg̕p) */
short unsigned int convendian_uint16(short unsigned int obj) {
  short unsigned int ret = 0;
  int i;
  
  for (i=0; i<2; i++) {
    ret = ret << 8;
    ret |= ((unsigned char *)&obj)[i];
  }
  
  return ret;
}
