#include <stdio.h>
#include <string.h>
#include "nksmf.h"

int main(int argc, char **argv) {
  FILE *fp;       /* t@C\̂ւ̃|C^ */
  SMFHEADER hdr;  /* wb_`Ni[ */
  int ret;        /* ߂lێ */
  int i;
  
  /* 1w肳ĂȂ΁CUsage\ďI */
  if (argc != 2) {
    fprintf(stderr, "usage: %s filename\n", argv[0]);
    return 1;
  }

  /* t@CJ */
  ret = smfOpenFile(&fp, argv[1]);
  if (ret) {
    fprintf(stderr, "smfOpenFile(): %s\n", strerror(ret));
    return 2;
  }
  
  /* wb_`FbN */
  if ( !smfHasValidHeader(fp) ) {
    fprintf(stderr, "Given file is not a valid SMF.\n");
    return 3;
  }

  /* wb_`Ñ_v */
  printf("----- Header Chunk -----\n");

  ret = smfGetHeaderChunk(fp, &hdr);
  if (ret != 0) {
    fprintf(stderr, "Cannot get the header chunk.\n");
    return 4;
  }
  
  for (i=0;i<4; i++) {
    printf("%c", hdr.chunktype[i]);
  }
  printf("\n");
  printf("hdr.length: %u\n", hdr.length);
  printf("hdr.format: %u\n", hdr.format);
  printf("hdr.numtrack: %u\n", hdr.numtrack);
  printf("hdr.timebase: %u\n", hdr.timebase);
  
  /* t@C */
  smfCloseFile(fp);

  return 0;
}
