/* wb_`N */
typedef struct smfheader {
  char chunktype[4];            /* `N^Cv: "MThd" */
  long unsigned int length;     /* f[^ */
  short unsigned int format;    /* tH[}bg^Cv */
  short unsigned int numtrack;  /* gbN */
  short unsigned int timebase;  /* ^Cx[X */
} SMFHEADER;

/* gbN`N */
typedef struct smftrack {
  char chunktype[4];           /* `N^Cv: "MTrk" */
  long unsigned int length;    /* f[^ */
  unsigned int start_pos;      /* 擪Cxg̈ʒu */
  unsigned int next_pos;       /* ̃Cxg̈ʒu */
  FILE *fp;
  struct smftrack *nexttrack;
} SMFTRACK;

/* gbNCxg */
typedef struct smfevent {
  long unsigned int deltatime;  /* f^^C */
  int eventtype;                /* Cxg^Cv */
  long unsigned int message;    /* MIDIbZ[W */
  char *data;                   /* Cxg^Cv܂ސf[^ */
  unsigned int data_length;     /* Cxg^Cv܂ސf[^̃f[^ */
} SMFEVENT;

#define SMF_UNKNOWN_EVENT  0
#define SMF_MIDI_EVENT     1
#define SMF_SYSEX_EVENT    2
#define SMF_META_EVENT     3

typedef struct smffile {
  FILE *fp;
  unsigned int firsttrack_pos;
  SMFTRACK *firsttrack;
} SMFFILE;

int smfOpenFile(SMFFILE *smf, char *filename);
int smfCloseFile(SMFFILE *smf);
int smfHasValidHeader(SMFFILE *smf);
int smfGetHeaderChunk(SMFFILE *smf, SMFHEADER *header);
SMFTRACK *smfGetFirstTrack(SMFFILE *smf);
SMFTRACK *smfGetNextTrack(SMFTRACK *track);
void smfRewindTrack(SMFTRACK *track);
SMFEVENT *smfGetNextEvent(SMFTRACK *track);
void smfFreeEvent(SMFEVENT *event);
