#include <stdio.h>
#include <string.h>
#include "nksmf.h"

int main(int argc, char **argv) {
  SMFFILE smf;
  SMFHEADER hdr;
  int ret;
  int i;
  
  if (argc != 2) {
    fprintf(stderr, "usage: %s filename\n", argv[0]);
    return 1;
  }

  memset(&smf, 0, sizeof(SMFFILE));
  ret = smfOpenFile(&smf, argv[1]);
  if (ret) {
    fprintf(stderr, "smfOpenFile(): %s\n", strerror(ret));
    return 2;
  }
  
  if ( !smfHasValidHeader(&smf) ) {
    fprintf(stderr, "Given file is not a valid SMF.\n");
    return 3;
  }

  printf("----- Header Chunk -----\n");

  ret = smfGetHeaderChunk(&smf, &hdr);
  if (ret != 0) {
    fprintf(stderr, "Cannot get the header chunk.\n");
    return 4;
  }

  for (i=0;i<4; i++) {
    printf("%c", hdr.chunktype[i]);
  }
  printf("\n");
  printf("hdr.length: %u\n", hdr.length);
  printf("hdr.format: %u\n", hdr.format);
  printf("hdr.numtrack: %u\n", hdr.numtrack);
  printf("hdr.timebase: %u\n", hdr.timebase);
  
  
  
  smfCloseFile(&smf);

  return 0;
}
