#include <stdio.h>

typedef struct header {
  char chunktype[4];
  int length;
} HEADER;

long int convert_endian_long(long int obj) {
  long int ret = 0;
  int i;
  
  for (i=0; i<4; i++) {
    ret = ret << 8;
    ret |= ((unsigned char *)&obj)[i];
  }
  
  return ret;
}

int main(void) {
  FILE *fp;
  char filename[] = "tokino_c.mid";
  HEADER h;
  long int buf_int4;

  printf("size of FILE: %d\n", sizeof(FILE));
  printf("size of chunktype %d\n", sizeof(h.chunktype));
  printf("size of long int %d\n", sizeof(long int));
  printf("size of short int %d\n", sizeof(short int));

  if ( (fp = fopen(filename, "r")) == NULL ) {
    printf("Cannot open file %s.\n", filename);
    return 1;
  }
  
  fread(h.chunktype, sizeof(h.chunktype), 1, fp);
  h.chunktype[ sizeof(h.chunktype) ] = '\0';
  printf("chunk type: %s\n", h.chunktype);

  fread(&buf_int4, sizeof(buf_int4), 1, fp);
  h.length = convert_endian_long(buf_int4);
  printf("chunk length (buf_int4): 0x%08X\n", buf_int4);
  printf("chunk length (h.length): 0x%08X\n", h.length);

  fclose(fp);

  return 0;
}
