#include <stdio.h>

long unsigned int read_variable_length_value(FILE *fp) {
  long unsigned int ret = 0;
  int buf = 0x80;
  
  while (buf & 0x80) {
    buf = fgetc(fp);
    if (buf == EOF) {
      return ( (long unsigned int)-1 ); /* value greater than 0x7FFFFFFF */
    }
    
    ret = ret << 7;
    ret |= buf & 0x7F;
  }
  
  return ret;
}

int main(void) {
  char filename[] = "variable_length_values";
  FILE *fp;
  
  if ( (fp = fopen(filename, "r")) == NULL ) {
    printf("Cannot open file %s.\n", filename);
    return 1;
  }
  
  printf("%08X\n", read_variable_length_value(fp));
  printf("%08X\n", read_variable_length_value(fp));
  printf("%08X\n", read_variable_length_value(fp));
  printf("%08X\n", read_variable_length_value(fp));
  printf("%08X\n", read_variable_length_value(fp));
  printf("%08X\n", read_variable_length_value(fp));
  
  fclose(fp);
  
  return 0;
}
