#include <stdio.h>
#include <stdlib.h>
#include <windows.h>
#include <mmsystem.h>

/* SysExpobt@̃TCY */
#define BUFSIZE 256

int end_of_program;

void CALLBACK MidiInProc(HMIDIIN hMidiIn, UINT wMsg, DWORD dwInstance,
                          DWORD dwParam1, DWORD dwParam2) {
  MIDIHDR *hdr;
  int i;

  switch (wMsg) {
    case MIM_OPEN:
      printf("MIDI device is opened.\n");
      break;
    case MIM_CLOSE:
      printf("MIDI device is closed.\n");
      break;
    case MIM_DATA:
      /* ANeBuZVO͕\Ȃ */
      if ( (dwParam1 & 0x000000ff) == 0xfe ) {
        break;
      }
      
      /*
      if ( ۑ7ō쐬 ) {
        end_of_program = 1;
        printf("end_of_program flag is on.\n");
      }
      */
      
      printf("MIM_DATA: wMsg=%08X, p1=%08X, p2=%08X\n",
             wMsg, dwParam1, dwParam2);
      break;
    case MIM_LONGDATA:
      printf("MIM_LONGDATA: ");
      hdr = (MIDIHDR*)dwParam1;  /* DWORD^MIDIHDR*^ւ̃LXg */
      printf("[%d bytes] ", hdr->dwBytesRecorded);  /* i[ꂽoCg\ */
      for (i=0; i<hdr->dwBytesRecorded; i++) {
        /* oCgƂ16iŕ\ */
        printf("%02X ", (unsigned char)((hdr->lpData)[i]));
      }
      printf("\n");

      /* ēxobt@ēo^ */
      midiInPrepareHeader(hMidiIn, hdr, sizeof(MIDIHDR));
      midiInAddBuffer(hMidiIn, hdr, sizeof(MIDIHDR));

      break;
    case MIM_ERROR:
    case MIM_LONGERROR:
    case MIM_MOREDATA:
    default:
      printf("MidiInProc: wMsg=%08X, p1=%08X, p2=%08X\n",
             wMsg, dwParam1, dwParam2);
      break;
  }
}

int main(int argc, char **argv) {
  HMIDIIN hMidiIn;
  MMRESULT res;
  MIDIHDR header;  /* SysExbZ[Wi[\ */
  UINT devid;
  char errmsg[MAXERRORLENGTH];

  if (argc > 1) {
    sscanf(argv[1], "%u", &devid);
  } else {
    devid = 0u;
  }

  /* MIDIHDR\̂̏ */
  ZeroMemory(&header, sizeof(MIDIHDR));    /* ̈0Ŗ߂ */
  header.lpData = (char*)malloc(BUFSIZE);  /* BUFSIZEoCgm */
  header.dwBufferLength = BUFSIZE;         /* obt@̗eʂݒ */
  header.dwFlags = 0;

  res = midiInOpen(&hMidiIn, devid, (DWORD_PTR)MidiInProc, 0, CALLBACK_FUNCTION);
  if (res != MMSYSERR_NOERROR) {
    printf("Cannot open MIDI input device (ID=%u): ", devid);
    midiInGetErrorText(res, errmsg, sizeof(errmsg));
    printf("%s\n", errmsg);
    return 1;
  }
  printf("Succeeded to open a MIDI input device (ID=%u).\n", devid);

  /* SysExpobt@Co^ */
  midiInPrepareHeader(hMidiIn, &header, sizeof(MIDIHDR));
  midiInAddBuffer(hMidiIn, &header, sizeof(MIDIHDR));

  midiInStart(hMidiIn);

  end_of_program = 0;
  while ( !end_of_program ) {
    Sleep(10);
  }

  midiInStop(hMidiIn);
  midiInReset(hMidiIn);

  /* SysExpobt@̏N[Abv */
  midiInUnprepareHeader(hMidiIn, &header, sizeof(MIDIHDR));

  midiInClose(hMidiIn);
  printf("Closed a MIDI input device.\n");

  free(header.lpData);  /* obt@̃̈ */

  return 0;
}
